// Statistik.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "Fuenf.h"
#include "Statistik.h"
#include "DialogNeu.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CStatistik 


CStatistik::CStatistik(CWnd* pParent /*=NULL*/)
	: CDialog(CStatistik::IDD, pParent)
{
	//{{AFX_DATA_INIT(CStatistik)
	m_Relation = _T("");
	m_Textlaenge = 0;
	m_Wortschatz = 0;
	//}}AFX_DATA_INIT
}


void CStatistik::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CStatistik)
	DDX_Control(pDX, IDC_LIST, m_Liste);
	DDX_Text(pDX, IDC_EDIT_RELATION, m_Relation);
	DDX_Text(pDX, IDC_EDIT_TEXTLAENGE, m_Textlaenge);
	DDX_Text(pDX, IDC_EDIT_WORTSCHATZ, m_Wortschatz);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CStatistik, CDialog)
	//{{AFX_MSG_MAP(CStatistik)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CStatistik 


// Analyse des Textes und Vorbereitung Tabelle
BOOL CStatistik::OnInitDialog() 
{
	// Standardroutinen aufrufen
	CDialog::OnInitDialog();

	// Makro zur Vereinfachung der Wortsuche in der Tabelle
#define FindenUndEintragen(was,wortart)	  { strWortstamm = Wortstamm(was,wortart);	\
											if (strWortstamm!="")					\
											{ nWortart = wortart;					\
											  nIndex = FindeWort(strWortstamm);	} }
	
	// Spalten in der Tabelle erzeugen
	m_Liste.InsertColumn(0,"Wort",LVCFMT_LEFT,250);
	m_Liste.InsertColumn(2,"Wortart",LVCFMT_LEFT,100);
	m_Liste.InsertColumn(3,"Hufigkeit",LVCFMT_RIGHT,90);

	// Variablen initialisieren
	int nWortschatz = 0;
	int nWortAnzahl = 0;

	// Histogramm auf 200 Buchstaben begrenzen
	arHistogramm.SetSize(cMaxBuchstaben);
	
	// Wort und Wortstamm
	CString strWort, strWortstamm;
	// Position im Text
	int nPos = 0;
	// Index in Tabelle
	int nIndex;
	// Wortart
	int nWortart;
	// Satzanfang extra vermerken, jeder Text beginnt mit diesem
	bool bSatzanfang = true;

	// alle Entscheidungen festhalten
	m_Entscheidung = "Um Entscheidung wurde gebeten bei:\n";

	// kompletten Text durchlaufen
	while (nPos<strText.GetLength())
	{
		// noch nicht bearbeiteten Teil abtrennen
		CString strTeilText = strText.Right(strText.GetLength()-nPos);
		// Wort extrahieren
		strWort = strTeilText.SpanIncluding("ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz");
		
		// nur wenn sinnvolles Wort
		if (strWort!="")
		{
			// Position anpassen
			nPos += strWort.GetLength();
			// Wortanzahl erhhen
			nWortAnzahl++;
			// im Histogramm vermerken
			arHistogramm[strWort.GetLength()]++;

			// von Wortart Sonstiges ausgehen
			nWortart = cSonstiges;

			// Wort in Tabelle suchen
			nIndex = FindeWort(strWort);

			// Wort nicht gefunden, aber Satzanfang
			if ((nIndex==-1)&&bSatzanfang)
			{
				// kleingeschriebenes Wort
				CString strHilf = strWort;
				strHilf.MakeLower();

				// Wort suchen
				nIndex = FindeWort(strHilf);

				// wenn nicht gefunden, dann als Verb suchen
				if (nIndex==-1)
					FindenUndEintragen(strHilf,cVerb);

				// wenn nicht gefunden, dann als Adjektiv suchen
				if (nIndex==-1)
					FindenUndEintragen(strHilf,cAdjektiv);

				// wenn nicht gefunden, dann als Artikel suchen
				if (nIndex==-1)
					FindenUndEintragen(strHilf,cArtikel);
			}

			// wenn nicht gefunden, dann als Substantiv suchen
			if (nWortart==cSonstiges)
				FindenUndEintragen(strWort,cSubstantiv);

			// wenn nicht gefunden, dann als Verb suchen
			if (nWortart==cSonstiges)
				FindenUndEintragen(strWort,cVerb);

			// wenn nicht gefunden, dann als Adjektiv suchen
			if (nWortart==cSonstiges)
				FindenUndEintragen(strWort,cAdjektiv);

			// wenn nicht gefunden, dann als Artikel suchen
			if (nWortart==cSonstiges)
				FindenUndEintragen(strWort,cArtikel);

			// wenn nicht gefunden und folgender Punkt, dann Abkrzung
			if ((nWortart==cSonstiges)&&(strText[nPos]=='.'))
				nWortart = cAbkuerzung;

			// Wort gefunden
			if (nIndex!=-1)
			{
				// Hufigkeit lesen
				CString strZahl;
				// gleich um 1 erhhen
				int nAnzahl = m_Liste.GetItemData(nIndex)+1;
				// neue Hufigkeit setzen
				m_Liste.SetItemData(nIndex,nAnzahl);
				// als Zeichenkette
				strZahl.Format("%i",nAnzahl);
				// in Tabelle eintragen
				m_Liste.SetItemText(nIndex,2,strZahl);
			}
			else
			{
				// falls berhaupt kein Wortstamm erkannt
				if (strWortstamm=="")
					strWortstamm = strWort;

				// Wort in Tabelle einfgen
				Neu(strWort, strWortstamm, nWortart);
				// demzufolge Wortschatz erhhen
				nWortschatz++;
			}

			// Satzanfang gilt nur fr erstes Wort
			bSatzanfang = false;
		}

		// auf Satzende untersuchen, dann ist nchstes Wort Satzanfang
		switch(strText[nPos])
		{
		case '.':
		case '?':
		case '!': bSatzanfang = true;
		}

		// auf jedes Wort folgt immer ein Nicht-Buchstabe im Text
		nPos++;
	}

	// alle Wrter anzeigen, ber die entschieden wurde
	AfxMessageBox(m_Entscheidung);

	// Wortschatz, Wortanzahl und das Verhltnis in % ausgeben
	m_Wortschatz = nWortschatz;
	m_Textlaenge = nWortAnzahl;
	m_Relation.Format("%i %%",(100*nWortschatz)/nWortAnzahl);
	
	// Dialog aktualisieren
	UpdateData(false);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX-Eigenschaftenseiten sollten FALSE zurckgeben
#undef FindenUndEintragen
}


// Wort neu einfgen
void CStatistik::Neu(CString strWort, CString strWortstamm, int nWortart)
{
	// Entscheidung vermerken
	m_Entscheidung += strWort+", ";
	
	// Dialog erstellen
	CDialogNeu DialogNeu;

	// Wort, Wortstamm und Wortart bermitteln
	DialogNeu.m_Wort = strWort;
	DialogNeu.m_Wortstamm = strWortstamm;
	DialogNeu.m_Wortart = nWortart;

	// Dialog ausfhren
	DialogNeu.DoModal();

	// Wortstamm auslesen
	strWort = DialogNeu.m_Wortstamm;
	// Artikel extra umsetzen
	if (DialogNeu.m_Wortart==cArtikel)
		strWort = "der/die/das";
		
	// durch Benutzereingabe so verndert, da doch schon in Tabelle ?
	int	nIndex = FindeWort(strWort);
	
	// falls nicht, dann einfgen
	if (nIndex==-1)
	{
		// Wort einfgen, Hufigkeit auf 1
		nIndex = m_Liste.InsertItem(-1,strWort);
		m_Liste.SetItemText(nIndex,2,"1");
		m_Liste.SetItemData(nIndex,1);

		// entsprechende Wortart einfgen
		switch(DialogNeu.m_Wortart)
		{
		case cSubstantiv: m_Liste.SetItemText(nIndex,1,"Substantiv"); break;
		case cVerb      : m_Liste.SetItemText(nIndex,1,"Verb"); break;
		case cAbkuerzung: m_Liste.SetItemText(nIndex,1,"Abkrzung"); break;
		case cAdjektiv  : m_Liste.SetItemText(nIndex,1,"Adjektiv"); break;
		case cArtikel   : m_Liste.SetItemText(nIndex,1,"Artikel"); break;
		case cSonstiges : m_Liste.SetItemText(nIndex,1,"Sonstiges"); 
		}
	}
	else
	{
		// Wort doch schon vorhanden, also nur Hufigkeit erhhen
		CString strZahl;
		int nAnzahl = m_Liste.GetItemData(nIndex)+1;
		m_Liste.SetItemData(nIndex,nAnzahl);
		strZahl.Format("%i",nAnzahl);
		m_Liste.SetItemText(nIndex,2,strZahl);
	}
}


// Histogramm ausgeben
void CStatistik::OnOK() 
{
	// Ausgabetext
	CString strAusgabe = "Wortschatz-Histogramm:\n\n";

	// fr jede mgliche Buchstabenlnge durchlaufen
	for (int nLauf=0; nLauf<cMaxBuchstaben; nLauf++)
	{
		CString strHinzu;
		// falls Wrter dieser Lnge, dann Anzahl feststellen
		if (arHistogramm[nLauf]!=0)
			strHinzu.Format("%3i Buchstaben %3imal\n", nLauf,arHistogramm[nLauf]);

		// zum Ausgabetext hinzufgen
		strAusgabe += strHinzu;
	}

	// Histogramm ausgeben
	AfxMessageBox(strAusgabe);
}


// Wortstamm ermitteln
CString CStatistik::Wortstamm(CString strWort, int nTyp)
{
// grogeschriebenes Wort ?
#define Gross (((strWort[0]>='A')&&(strWort[0]<='Z'))||\
				(strWort[0]=='')||(strWort[0]=='')||(strWort[0]==''))
// Endung ggf. herausfiltern
#define Endung(was,laenge) 	if (strWort.Find(was)==strWort.GetLength()-laenge)\
							strWortstamm = strWort.Left(strWort.GetLength()-laenge);

	CString strWortstamm = "";

	// Wortarten unterscheiden
	switch (nTyp)
	{
	case cSubstantiv:
		// kleingeschriebene Wrter abweisen
		if (!Gross)
			break;

		// erstmal alle Wrter als Substantive akzeptieren
		strWortstamm = strWort;
		
		// Singular Genitiv m-w-n
		Endung("es",2)

		// Singular Dativ m-w-n/ Plural Nominativ m
		Endung("e",1);

		// Plural Nominativ
		Endung("en",2);

		// Plural Nominativ
		Endung("n",1);

		break;

	case cVerb:
		// grogeschriebene Wrter abweisen
		if (Gross)
			break;

		// Prsens
		// ich
		Endung("e",1);
		// du
		Endung("st",2);
		// er/sie/es/ihr
		Endung("t",1);
		// wir/sie(pl)
		Endung("en",2);

		// Prteritum
		// ich
		Endung("te",1);
		// du
		Endung("test",2);
		// er/sie/es/ihr
		Endung("tet",1);
		// wir/sie(pl)
		Endung("ten",2);

		// Infinitiv herstellen
		if(strWortstamm!="")
			strWortstamm += "en";
		
		break;

	case cAdjektiv:
		// grogeschriebene Wrter abweisen
		if (Gross)
			break;

		// mgliche Endungen
		Endung("e",1);
		Endung("en",2);
		Endung("es",2);
		Endung("er",2);

		break;

	case cArtikel:
		// grogeschriebene Wrter abweisen
		if (Gross)
			break;
		
		// alle Artikel zusammenfassen
		if ((strWort=="der")||(strWort=="die")||(strWort=="das")||
			(strWort=="des")||(strWort=="dem")||(strWort=="den"))
			strWortstamm = "der/die/das";

		break;
	}

	// Wortstamm zurckgeben
	return strWortstamm;
#undef Endung
#undef Gross
}


// Wort in Tabelle finden
int CStatistik::FindeWort(CString strWort)
{
	// unzulssige Parameter abweisen
	if (strWort=="")
		return -1;
	
	// Anzahl Eintrge in Tabelle
	int nAnzahl = m_Liste.GetItemCount();
	// wenn leer, dann Suche beenden
	if (nAnzahl==0)
		return -1;

	// alle Wrter durchlaufen
	for (int nLauf = 0; nLauf<nAnzahl; nLauf++)
		// wenn Wort gefunden, dann Index zurckliefern
		if (strWort==m_Liste.GetItemText(nLauf,0))
			return nLauf;

	return -1;
}
